'****************************************************************
'*  Name    : USB_MD_MKR.INC                                    *
'*  Author  : Gabi Mihaila                                      *
'*  Notice  : Copyright (c) 2007 Orbtronics                     *
'*          : All Rights Reserved                               *
'*  Date    : 2/27/2007                                         *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************


Dim PP0 As Byte System        ' USBPOLL status return
Dim PP2 As Byte System        ' number of received bytes 

Dim DATA_PACKET[64] As Byte   ; this is the receiving buffer  
Dim OUT_PACKET[64] As Byte    ; this is the sending   buffer
Dim USB_PAK_LEN As Byte
Dim TEMP As Byte              ; dummy var

Symbol CARRY_FLAG = STATUS.0  ' high if microcontroller does not have control over the buffer
;* USB Device States  
Symbol	DETACHED_STATE	  =	0
Symbol	ATTACHED_STATE	  =	1
Symbol	POWERED_STATE	  =	2
Symbol	DEFAULT_STATE	  =	3
Symbol 	ADR_PENDING_STATE =	4
Symbol	ADDRESS_STATE	  =	5
Symbol	CONFIGURED_STATE  = 6

;*****************************************************************************************
;* CODE INDEX NUMBER CLASSIFICATIONS  
;* just some of them. For a full list, please check the MIDI10.pdf from http://www.usb.org
;*****************************************************************************************
Symbol  SysEx_Continue               $04   ; SysEx Starts or Continues
Symbol  Note_is_OFF                  $08   ; Note OFF
Symbol  Note_is_ON                   $09   ; Note ON
Symbol  Control_is_Change            $0B   ; Control Change
;*****************************************************************************************


bra OVER_MIDI_MACROS

Note_OFF Macro midi_channel, note_number
         #if (Prm_1 == Byte)
            BYTE_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_1 == Num8) | (Prm_1 == Num16)
            NUM_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_2 == Byte)
            BYTE_BYTE note_number, OUT_PACKET#2
         #endif
         #if (Prm_2 == Num8) | (Prm_2 == Num16)
            NUM_BYTE note_number , OUT_PACKET#2
         #endif
         GoSub Note_OFF_Sub
         Endm
Note_OFF_Sub:
         OUT_PACKET#0 = Note_is_OFF
         decf OUT_PACKET#1
         OUT_PACKET#1 = OUT_PACKET#1 | $80
         OUT_PACKET#3 = $40         ; Velocity. this can be added to macro parameters if needed 
         USBOut 3, OUT_PACKET, 64        
         While UIR.3 = 0 : Wend
         Return
         
Note_ON  Macro midi_channel, note_number
         #if (Prm_1 == Byte)
            BYTE_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_1 == Num8) | (Prm_1 == Num16)
            NUM_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_2 == Byte)
            BYTE_BYTE note_number, OUT_PACKET#2
         #endif
         #if (Prm_2 == Num8) | (Prm_2 == Num16)
            NUM_BYTE note_number , OUT_PACKET#2
         #endif
         GoSub Note_ON_Sub
         Endm
Note_ON_Sub:
         OUT_PACKET#0 = Note_is_ON
         decf OUT_PACKET#1
         OUT_PACKET#1 = OUT_PACKET#1 | $90
         OUT_PACKET#3 = $64         ; Velocity. this can be added to macro parameters if needed
         USBOut 3, OUT_PACKET, 64       
         While UIR.3 = 0 : Wend       
         Return         
         
Control_Change Macro midi_channel, controller_number, control_value
         #if (Prm_1 == Byte)
            BYTE_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_1 == Num8) | (Prm_1 == Num16)
            NUM_BYTE midi_channel, OUT_PACKET#1
         #endif
         #if (Prm_2 == Byte)
            BYTE_BYTE controller_number, OUT_PACKET#2
         #endif
         #if (Prm_2 == Num8) | (Prm_2 == Num16)
            NUM_BYTE controller_number, OUT_PACKET#2
         #endif
         #if (Prm_3 == Byte)
            BYTE_BYTE control_value, OUT_PACKET#3
         #endif
         #if (Prm_3 == Num8) | (Prm_3 == Num16)
            NUM_BYTE control_value, OUT_PACKET#3
         #endif
         GoSub Control_Change_Sub
         Endm
Control_Change_Sub:
         OUT_PACKET#0 = Control_is_Change
         decf OUT_PACKET#1
         OUT_PACKET#1 = OUT_PACKET#1 | $B0
         USBOut 3, OUT_PACKET, 64       
         While UIR.3 = 0 : Wend      
         Return                  


     
OVER_MIDI_MACROS:   
